﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class Ajax_Search : UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        RadAjaxManager AjaxManager = RadAjaxManager.GetCurrent(Page);
        if (AjaxManager != null)
        {
            AjaxManager.AjaxSettings.AddAjaxSetting(AjaxManager, RadListView1);
            AjaxManager.AjaxRequest += new RadAjaxControl.AjaxRequestDelegate(AjaxManager_AjaxRequest);
        }
    }

    protected void AjaxManager_AjaxRequest(object sender, AjaxRequestEventArgs e)
    {
        if (e.Argument.StartsWith("Search"))
        {
            string query = e.Argument.Split(':')[1];
            SearchByQuery(query);
        }
    }

    protected void SearchByQuery(string query)
    {
        RadListView1.FilterExpressions.Clear();

        RadListViewContainsFilterExpression expr = new RadListViewContainsFilterExpression(SearchTextField);
        expr.CurrentValue = query;
        RadListView1.FilterExpressions.Add(expr);

        RadListView1.Rebind();
    }

    protected void RadListView1_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
    {
        if (RadListView1.FilterExpressions.Count == 0)
        {
            return;
        }

        if(DataSource != null)
        {
            RadListView1.DataSource = DataSource;
        }
        else if (!String.IsNullOrEmpty(DataSourceID))
        {
            RadListView1.DataSource = Page.FindControl(DataSourceID);
        }
    }

    public object DataSource
    {
        get;
        set;
    }

    public string DataSourceID
    {
        get;
        set;
    }

    public string SearchTextField
    {
        get;
        set;
    }
}